## mysql-8.0 8.0.44

=== libmysql/CMakeLists.txt ===
# Copyright (c) 2006, 2025, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

ADD_WSHADOW_WARNING()

SET(CLIENT_API_FUNCTIONS
  mysql_affected_rows
  mysql_autocommit
  mysql_change_user
  mysql_character_set_name
  mysql_close
  mysql_commit
  mysql_data_seek
  mysql_debug
  mysql_dump_debug_info
  mysql_eof
  mysql_errno
  mysql_error
  mysql_escape_string
  mysql_fetch_field
  mysql_fetch_field_direct
  mysql_fetch_fields
  mysql_fetch_lengths
  mysql_fetch_row
  mysql_field_count
  mysql_field_seek
  mysql_field_tell
  mysql_free_result
  mysql_get_client_info
  mysql_get_client_version
  mysql_get_host_info
  mysql_get_proto_info
  mysql_get_server_info
  mysql_get_ssl_cipher
  mysql_hex_string
  mysql_info
  mysql_init
  mysql_insert_id
  mysql_kill
  mysql_list_dbs
  mysql_list_fields
  mysql_list_processes
  mysql_list_tables
  mysql_more_results
  mysql_next_result
  mysql_num_fields
  mysql_num_rows
  mysql_options
  mysql_ping
  mysql_query
  mysql_set_server_option
  mysql_stmt_bind_param
  mysql_stmt_bind_result
  mysql_stmt_execute
  mysql_stmt_fetch
  mysql_stmt_fetch_column
  mysql_stmt_param_count
  mysql_stmt_param_metadata
  mysql_stmt_result_metadata
  mysql_thread_end
  mysql_thread_init
  # We need to have document for this api
  mysql_read_query_result
  mysql_real_connect
  mysql_real_escape_string
  mysql_real_escape_string_quote
  mysql_real_query
  mysql_refresh
  mysql_rollback
  mysql_row_seek
  mysql_row_tell
  mysql_select_db
  mysql_stmt_send_long_data
  # We need to have document for this api
  mysql_client_find_plugin
  mysql_client_register_plugin
  mysql_get_character_set_info
  mysql_get_option
  mysql_get_server_version
  mysql_load_plugin
  mysql_load_plugin_v
  mysql_options4
  mysql_plugin_options
  mysql_reset_connection
  mysql_reset_server_public_key
  mysql_result_metadata
  mysql_send_query
  mysql_server_end
  mysql_server_init
  mysql_session_track_get_first
  mysql_session_track_get_next
  mysql_set_character_set
  mysql_set_local_infile_default
  mysql_set_local_infile_handler
  mysql_shutdown
  mysql_sqlstate
  mysql_ssl_set
  mysql_stat
  mysql_stmt_affected_rows
  mysql_stmt_attr_get
  mysql_stmt_attr_set
  mysql_stmt_close
  mysql_stmt_data_seek
  mysql_stmt_errno
  mysql_stmt_error
  mysql_stmt_field_count
  mysql_stmt_free_result
  mysql_stmt_init
  mysql_stmt_insert_id
  mysql_stmt_next_result
  mysql_stmt_num_rows
  mysql_stmt_prepare
  mysql_stmt_reset
  mysql_stmt_row_seek
  mysql_stmt_row_tell
  mysql_stmt_sqlstate
  mysql_stmt_store_result
  mysql_store_result
  mysql_thread_id
  mysql_thread_safe
  mysql_use_result
  mysql_warning_count
  mysql_real_connect_dns_srv
  mysql_bind_param
  mysql_plugin_get_option
  mysql_get_ssl_session_reused
  mysql_get_ssl_session_data
  mysql_free_ssl_session_data
  mysql_binlog_close
  mysql_binlog_fetch
  mysql_binlog_open
  CACHE INTERNAL "Functions exported by client API"
)

# Below list will have all the undocumented C API symbols but still exported.
# Once the decision is taken to have documentation we need to move them to
# CLIENT_API_FUNCTIONS list.
SET(CLIENT_API_FUNCTIONS_UNDOCUMENTED
  get_tty_password
  # my_load_defaults is a wrapper for load_defaults and it is not documented.
  # We will have a FR to replace this for decent name/functionality and
  # document it.
  my_load_defaults
  handle_options
  # pure-ftpd 1.0.42 needs either my_make_scrambled_password (preferred)
  # or make_scrambled_password.
  my_make_scrambled_password

  CACHE INTERNAL "Undocumented functions exported by client API"

)

# Below list will have all nonblocking C APIs
SET(CLIENT_API_NONBLOCKING_FUNCTIONS
  mysql_fetch_row_nonblocking
  mysql_free_result_nonblocking
  mysql_next_result_nonblocking
  mysql_real_connect_nonblocking
  mysql_real_query_nonblocking
  mysql_send_query_nonblocking
  mysql_store_result_nonblocking

  CACHE INTERNAL "Nonblocking functions exported by client API"
)

SET(CLIENT_SOURCES
  libmysql.cc
  errmsg.cc
  dns_srv.cc
  ../sql-common/client.cc
  ../sql-common/client_plugin.cc
  ../sql-common/client_authentication.cc
  ../sql-common/compression.cc
  ../sql-common/get_password.cc
  ../sql-common/net_serv.cc
  ../sql-common/bind_params.cc
  ../sql/auth/password.cc
  ../sql/auth/sha2_password_common.cc
)

IF (WIN32 AND OPENSSL_APPLINK_C)
  MY_ADD_COMPILE_DEFINITIONS(
    ../sql-common/client_authentication.cc
    COMPILE_DEFINITIONS HAVE_OPENSSL_APPLINK_C
  )
ENDIF()

#
# Include protocol tracing infrastructure and the test
# trace plugin if enabled by build options.
#
IF (WITH_CLIENT_PROTOCOL_TRACING)

  LIST(APPEND CLIENT_SOURCES mysql_trace.cc)
  ADD_DEFINITIONS(-D CLIENT_PROTOCOL_TRACING)

  IF (WITH_TEST_TRACE_PLUGIN)
    MESSAGE(STATUS "Client library contains the test trace plugin")
    LIST(APPEND CLIENT_SOURCES test_trace_plugin.cc)
    ADD_DEFINITIONS(-D TEST_TRACE_PLUGIN)
  ENDIF (WITH_TEST_TRACE_PLUGIN)

ENDIF (WITH_CLIENT_PROTOCOL_TRACING)

ADD_CONVENIENCE_LIBRARY(clientlib ${CLIENT_SOURCES}
  DEPENDENCIES GenError
  LINK_LIBRARIES ext::zlib
  )

SET(LIBS_TO_MERGE
  clientlib mytime strings vio mysys
  )
SET(LIBS_TO_LINK ${LIBDL})

IF(WITH_ZLIB STREQUAL "bundled")
  LIST(APPEND LIBS_TO_MERGE zlib)
ELSE()
  LIST(APPEND LIBS_TO_LINK ext::zlib)
ENDIF()

IF(WITH_ZSTD STREQUAL "bundled")
  LIST(APPEND LIBS_TO_MERGE zstd)
ELSE()
  LIST(APPEND LIBS_TO_LINK ext::zstd)
ENDIF()

LIST(APPEND LIBS_TO_LINK ${SSL_LIBRARIES})

IF(WITH_EXT_BACKTRACE)
  LIST(APPEND LIBS_TO_MERGE backtrace)
ENDIF()

UNSET(HAVE_WIN32_DNS_SRV)
UNSET(HAVE_UNIX_DNS_SRV)
SET(HAVE_DNS_SRV 0)
IF(WIN32)
  LIST(APPEND LIBS_TO_LINK dnsapi)
  SET(HAVE_WIN32_DNS_SRV 1 PARENT_SCOPE)
  SET(HAVE_DNS_SRV 1)
  MESSAGE(STATUS "Found Win32 DNS SRV APIs")
ELSEIF(FREEBSD)
  SET(HAVE_DNS_SRV 1)
  SET(HAVE_UNIX_DNS_SRV 1 PARENT_SCOPE)
  MESSAGE(STATUS "BSD built in DNS SRV APIs")
ELSE()
  FIND_LIBRARY(RESOLV_LIBRARY NAMES resolv)
  IF (RESOLV_LIBRARY)
    LIST(APPEND LIBS_TO_LINK ${RESOLV_LIBRARY})
    SET(HAVE_UNIX_DNS_SRV 1 PARENT_SCOPE)
    SET(HAVE_DNS_SRV 1)
    MESSAGE(STATUS "Found Unix DNS SRV APIs")
  ENDIF()
ENDIF()

IF(HAVE_DNS_SRV EQUAL 0)
  MESSAGE(FATAL_ERROR "Can't find neither Win32 nor Unix DNS SRV APIs")
ENDIF()
#
# On Windows platform client library includes the client-side
# Windows Native Authentication plugin.
#
IF(WIN32)
  ADD_DEFINITIONS(-DAUTHENTICATION_WIN)
  ADD_SUBDIRECTORY(authentication_win)
  LIST(APPEND LIBS_TO_MERGE auth_win_client)
ENDIF()

# LDAP authentication SASL client plug-in
ADD_SUBDIRECTORY(authentication_ldap)

# FIDO authentication client plugin
ADD_SUBDIRECTORY(authentication_fido)

# authentication kerberos client plug-in
ADD_SUBDIRECTORY(authentication_kerberos)

# authentication IAM client plug-in
ADD_SUBDIRECTORY(authentication_oci_client)

# Merge several convenience libraries into one big mysqlclient
MERGE_CONVENIENCE_LIBRARIES(mysqlclient ${LIBS_TO_MERGE}
  COMPONENT Development
  LINK_LIBRARIES ${LIBS_TO_LINK}
  )

# Visual Studio users need debug  static library for debug projects
IF(MSVC)
  INSTALL_DEBUG_TARGET(mysqlclient DESTINATION ${INSTALL_LIBDIR}/debug)

  INSTALL_DEBUG_TARGET(auth_win_client DESTINATION ${INSTALL_LIBDIR}/debug)
  INSTALL_DEBUG_TARGET(clientlib DESTINATION ${INSTALL_LIBDIR}/debug)
  INSTALL_DEBUG_TARGET(mysys DESTINATION ${INSTALL_LIBDIR}/debug)
  INSTALL_DEBUG_TARGET(strings DESTINATION ${INSTALL_LIBDIR}/debug)
  INSTALL_DEBUG_TARGET(vio DESTINATION ${INSTALL_LIBDIR}/debug)
  IF(WITH_ZLIB STREQUAL "bundled")
    INSTALL_DEBUG_TARGET(zlib DESTINATION ${INSTALL_LIBDIR}/debug)
  ENDIF()
  IF(WITH_ZSTD STREQUAL "bundled")
    INSTALL_DEBUG_TARGET(zstd DESTINATION ${INSTALL_LIBDIR}/debug)
  ENDIF()
ENDIF()

IF(UNIX)
  MACRO(GET_VERSIONED_LIBNAME LIBNAME EXTENSION VERSION OUTNAME)
    SET(DOT_VERSION ".${VERSION}")
    IF(DOT_VERSION STREQUAL ".")
      SET(DOT_VERSION "")
    ENDIF()
    IF(APPLE)
      SET(${OUTNAME} ${LIBNAME}${DOT_VERSION}${EXTENSION})
    ELSE()
      SET(${OUTNAME} ${LIBNAME}${EXTENSION}${DOT_VERSION})
    ENDIF()
  ENDMACRO()
ENDIF()

IF(UNIX)
  SET(OS_SHARED_LIB_VERSION "${SHARED_LIB_MAJOR_VERSION}")
  IF(NOT FREEBSD AND NOT APPLE)
    STRING_APPEND(OS_SHARED_LIB_VERSION
      ".${SHARED_LIB_MINOR_VERSION}.${SHARED_LIB_PATCH_VERSION}")
  ENDIF()
  # Name of shared library is libmysqlclient on Unix
  SET(UNIX_OUTPUT_NAME OUTPUT_NAME mysqlclient)
  SET(UNIX_VERSION     VERSION     "${OS_SHARED_LIB_VERSION}")
  SET(UNIX_SOVERSION   SOVERSION   "${SHARED_LIB_MAJOR_VERSION}")
ENDIF()

# Merge several convenience libraries into one big mysqlclient
# and link them together into shared library.
MERGE_LIBRARIES_SHARED(libmysql ${LIBS_TO_MERGE}
  EXPORTS
  ${CLIENT_API_FUNCTIONS}
  ${CLIENT_API_FUNCTIONS_UNDOCUMENTED}
  ${CLIENT_API_NONBLOCKING_FUNCTIONS}
  COMPONENT SharedLibraries
  LINK_LIBRARIES ${LIBS_TO_LINK}
  ${UNIX_OUTPUT_NAME}
  ${UNIX_SOVERSION}
  ${UNIX_VERSION}
  )

# Downgrade warning for strncat in my_crypt_genhash.
IF((WITH_LTO OR CMAKE_COMPILER_FLAG_WITH_LTO) AND MY_COMPILER_IS_GNU)
  MY_TARGET_LINK_OPTIONS(libmysql "-Wno-error=stringop-truncation")
ENDIF()

IF(LINUX_STANDALONE AND KERBEROS_CUSTOM_LIBRARY)
  ADD_DEPENDENCIES(libmysql ${kerberos_target})
  ADD_DEPENDENCIES(mysqlclient ${kerberos_target})
ENDIF()

IF(UNIX)
  IF(LINK_FLAG_Z_DEFS)
    MY_TARGET_LINK_OPTIONS(libmysql "LINKER:${LINK_FLAG_Z_DEFS}")
  ENDIF()

  IF(LINUX)
    CONFIGURE_FILE(libmysql.ver.in ${CMAKE_CURRENT_BINARY_DIR}/libmysql.ver)
    MY_TARGET_LINK_OPTIONS(libmysql
      "LINKER:--version-script=${CMAKE_CURRENT_BINARY_DIR}/libmysql.ver")
  ENDIF()

  # clean direct output needs to be set several targets have the same name
  #(mysqlclient in this case)
  SET_TARGET_PROPERTIES(mysqlclient PROPERTIES CLEAN_DIRECT_OUTPUT 1)
  SET_TARGET_PROPERTIES(libmysql PROPERTIES CLEAN_DIRECT_OUTPUT 1)
ENDIF()

#
#  Basic application for testing linking against dynamic client library.
#

#
# Generate a comma separated list of C API functions which is used
# to initialize api_calls[] array in api_test.c
#
SET(CLIENT_API_FUNCTION_LIST "")
FOREACH(api ${CLIENT_API_FUNCTIONS})
  SET(CLIENT_API_FUNCTION_LIST "${CLIENT_API_FUNCTION_LIST} ${api},")
ENDFOREACH()
FOREACH(api ${CLIENT_API_NONBLOCKING_FUNCTIONS})
  SET(CLIENT_API_FUNCTION_LIST "${CLIENT_API_FUNCTION_LIST} ${api},")
ENDFOREACH()

#
# Generate api_test.c source, substituting @CLIENT_API_FUNCTION_LIST@
# with the list of API functions.
#
CONFIGURE_FILE(api_test.c.in ${CMAKE_CURRENT_BINARY_DIR}/api_test.c)

#
# Note: Compiling this test application will fail if not all symbols
# from @CLIENT_API_FUNCTIONS@ are declared by <mysql.h>. It will fail
# to run if not all of these symbols are exported by the library.
#
MYSQL_ADD_EXECUTABLE(libmysql_api_test
  ${CMAKE_CURRENT_BINARY_DIR}/api_test.c
  LINK_LIBRARIES libmysql ${LIBRT}
  SKIP_INSTALL
  )
# Clang/UBSAN needs this on some platforms.

=== router/CMakeLists.txt ===
# Copyright (c) 2015, 2025, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

INCLUDE(cmake/version.cmake)
SET(CMAKE_MODULE_PATH
  ${CMAKE_MODULE_PATH}
  "${CMAKE_SOURCE_DIR}"
  "${CMAKE_CURRENT_SOURCE_DIR}"
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

# enable MACOSX_RPATH
CMAKE_POLICY(SET CMP0042 NEW)
# warn about non-existing dependencies in add_dependencies()
CMAKE_POLICY(SET CMP0046 NEW)
# set the VERSION as documented in PROJECT() command
CMAKE_POLICY(SET CMP0048 NEW)
# only interpret if() arguments as variables or keywords when unquoted
CMAKE_POLICY(SET CMP0054 NEW)
PROJECT("MySQLRouter" VERSION ${PROJECT_VERSION_TEXT} LANGUAGES C CXX)
MSVC_CPPCHECK_DISABLE()

# In CMake 3.12 and above, the
#
# * ``check_include_file`` macro in the ``CheckIncludeFile`` module, the
# * ``check_include_file_cxx`` macro in the
#   ``CheckIncludeFileCXX`` module, and the
# * ``check_include_files`` macro in the ``CheckIncludeFiles`` module
#
# now prefer to link the check executable to the libraries listed in the
# ``CMAKE_REQUIRED_LIBRARIES`` variable.
IF(POLICY CMP0075)
  CMAKE_POLICY(SET CMP0075 NEW)
ENDIF()

IF(SOLARIS)
  # disable rapidjson optimisation on Solaris as it breaks
  # shared objects that build with -fPIC
  ADD_DEFINITIONS(-DRAPIDJSON_48BITPOINTER_OPTIMIZATION=0)

  # MD5_Init() and others are deprecated.
  IF(MY_COMPILER_IS_GNU_OR_CLANG)
    ADD_COMPILE_OPTIONS("-Wno-deprecated-declarations")
  ENDIF()
ENDIF()

# ld.lld: error: corrupt input file:
# version definition index 0 for symbol __gcov_var is out of bounds
IF(ENABLE_GCOV)
  STRING(REPLACE "-fuse-ld=lld" ""
    CMAKE_C_LINK_FLAGS "${CMAKE_C_LINK_FLAGS}")
  STRING(REPLACE "-fuse-ld=lld" ""
    CMAKE_CXX_LINK_FLAGS "${CMAKE_CXX_LINK_FLAGS}")
  STRING(REPLACE "-Wl,--gdb-index" ""
    CMAKE_C_LINK_FLAGS "${CMAKE_C_LINK_FLAGS}")
  STRING(REPLACE "-Wl,--gdb-index" ""
    CMAKE_CXX_LINK_FLAGS "${CMAKE_CXX_LINK_FLAGS}")
ENDIF()

DISABLE_MISSING_PROFILE_WARNING()

IF(WIN32)
  # 'identifier' : class 'type' needs to have dll-interface to be used
  # by clients of class 'type2'
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4251")
ENDIF()

INCLUDE(${CMAKE_SOURCE_DIR}/cmake/rapidjson.cmake)

SET(ROUTER_LICENSE_FILE "${CMAKE_SOURCE_DIR}/router/LICENSE.router")
SET(ROUTER_README_FILE "${CMAKE_SOURCE_DIR}/router/README.router")

SET(DOC_DESTINATION ".")
IF(NOT INSTALL_LAYOUT MATCHES "RPM")
  INSTALL(FILES
      ${ROUTER_LICENSE_FILE}
      ${ROUTER_README_FILE}
      DESTINATION ${DOC_DESTINATION} COMPONENT Router OPTIONAL)
ENDIF()

INCLUDE(cmake/settings.cmake)
INCLUDE(cmake/set_rpath.cmake)

# Required tools, libraries, etc..
INCLUDE(cmake/testing.cmake)  # does not enable testing
INCLUDE(cmake/configure.cmake)
INCLUDE(cmake/packaging.cmake)
INCLUDE(cmake/Plugin.cmake)
INCLUDE(cmake/fuzzer.cmake)

INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/include)

# a meta-target to allow build everything router related, but nothing that
# it doesn't depend on
#
# each target needs to add itself via
#
#   ADD_DEPENDENCIES(mysqlrouter_all ...)
#
ADD_CUSTOM_TARGET(mysqlrouter_all)

# Load all modules, including plugins
ADD_SUBDIRECTORY(src)

# Enable testing


IF(WITH_UNIT_TESTS)
  ADD_SUBDIRECTORY(tests)
ENDIF()

=== testclients/CMakeLists.txt ===
# Copyright (c) 2006, 2025, Oracle and/or its affiliates.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

ADD_WSHADOW_WARNING()

MYSQL_ADD_EXECUTABLE(mysql_client_test mysql_client_test.cc COMPONENT Test)
TARGET_LINK_LIBRARIES(mysql_client_test mysqlclient extra::rapidjson)

# We *do* calculate that there is space, see:
# printf("Warning: MYSQL_TMP_DIR is too long. Logging is disabled.\n");
IF(MY_COMPILER_IS_GNU AND CMAKE_BUILD_TYPE_UPPER STREQUAL "RELWITHDEBINFO")
  ADD_COMPILE_FLAGS(mysql_client_test.cc
    COMPILE_FLAGS "-Wno-error=format-truncation")
ENDIF()

IF(WITH_UNIT_TESTS)
  MYSQL_ADD_EXECUTABLE(bug25714 bug25714.cc
    SKIP_INSTALL
    EXCLUDE_FROM_PGO
    LINK_LIBRARIES mysqlclient)
ENDIF()

=== extra/libbacktrace/CMakeLists.txt ===
# Copyright (c) 2023, 2025, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is also distributed with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have included with MySQL.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

INCLUDE(libutils)

SET(BACKTRACE_VERSION sha793921876c981)
SET(BACKTRACE_SOURCES
  ${BACKTRACE_VERSION}/backtrace.c
  ${BACKTRACE_VERSION}/dwarf.c
  ${BACKTRACE_VERSION}/elf.c
  ${BACKTRACE_VERSION}/fileline.c
  ${BACKTRACE_VERSION}/mmap.c
  ${BACKTRACE_VERSION}/mmapio.c
  ${BACKTRACE_VERSION}/posix.c
  ${BACKTRACE_VERSION}/print.c
  ${BACKTRACE_VERSION}/simple.c
  ${BACKTRACE_VERSION}/sort.c
  ${BACKTRACE_VERSION}/state.c
)
SET(BACKTRACE_DEFINITIONS
  BACKTRACE_ELF_SIZE=64
  BACKTRACE_XCOFF_SIZE=unused
  HAVE_ATOMIC_FUNCTIONS=1
  HAVE_CLOCK_GETTIME=1
  HAVE_DECL_GETPAGESIZE=1
  HAVE_DECL_STRNLEN=1
  HAVE_DECL__PGMPTR=0
  HAVE_DLFCN_H=1
  HAVE_DL_ITERATE_PHDR=1
  HAVE_FCNTL=1
  HAVE_GETIPINFO=1
  HAVE_INTTYPES_H=1
  HAVE_LINK_H=1
  HAVE_LSTAT=1
  HAVE_MEMORY_H=1
  HAVE_READLINK=1
  HAVE_STDINT_H=1
  HAVE_STDLIB_H=1
  HAVE_STRINGS_H=1
  HAVE_STRING_H=1
  HAVE_SYNC_FUNCTIONS=1
  HAVE_SYS_MMAN_H=1
  HAVE_SYS_STAT_H=1
  HAVE_SYS_TYPES_H=1
  HAVE_UNISTD_H=1
)
IF(FREEBSD)
  LIST(APPEND BACKTRACE_DEFINITIONS
    HAVE_KERN_PROC=1
    HAVE_KERN_PROC_ARGS=1
    )
ENDIF()

# Ensure no tail-call optimization to stabilize the number of reported frames
ADD_COMPILE_FLAGS(src/stacktrace.cc COMPILE_FLAGS -fno-optimize-sibling-calls)

ADD_CONVENIENCE_LIBRARY(backtrace ${BACKTRACE_SOURCES} src/stacktrace.cc
  INCLUDE_DIRECTORIES PRIVATE include/
  COMPILE_OPTIONS PRIVATE -funwind-tables
  COMPILE_DEFINITIONS PRIVATE ${BACKTRACE_DEFINITIONS}
)
TARGET_COMPILE_DEFINITIONS(backtrace INTERFACE HAVE_EXT_BACKTRACE)
TARGET_COMPILE_DEFINITIONS(backtrace_objlib INTERFACE HAVE_EXT_BACKTRACE)

TARGET_INCLUDE_DIRECTORIES(backtrace INTERFACE include/)

=== packaging/deb-in/CMakeLists.txt ===
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

IF(NOT LINUX)
  RETURN()
ENDIF()

# bionic, buster, etc
IF (NOT DEFINED DEB_CODENAME)
  execute_process(
    COMMAND lsb_release -cs
    OUTPUT_VARIABLE DEB_CODENAME
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  SET (DEB_CODENAME ${DEB_CODENAME} CACHE STRING "")
ENDIF()

# debian, ubuntu
IF (NOT DEFINED DEB_ID)
  execute_process(
    COMMAND lsb_release -is
    OUTPUT_VARIABLE DEB_ID
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  SET (DEB_ID ${DEB_ID} CACHE STRING "")
ENDIF()

# 18.04, 9.x, etc
IF (NOT DEFINED DEB_RELEASE)
  execute_process(
    COMMAND lsb_release -rs
    OUTPUT_VARIABLE DEB_RELEASE
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  SET (DEB_RELEASE ${DEB_RELEASE} CACHE STRING "")
ENDIF()

# Change uppercase first letter of Ubuntu/Debian
string(TOLOWER "${DEB_ID}" DEB_ID)

# Ubuntu 20.04 and 22.04 has too old zlib
IF(DEB_CODENAME STREQUAL "focal" OR DEB_CODENAME STREQUAL "jammy")
  SET (DEB_ZLIB_OPTION "bundled")
ELSE()
  SET (DEB_ZLIB_OPTION "system")
ENDIF()

IF (WITH_NDB)
  SET (DEB_BASE_PRODUCT "cluster-")
  SET (DEB_BASE_PRODUCTC "Cluster ")
  SET (DEB_BASE_VERSION ${MYSQL_CLUSTER_VERSION})
  SET (DEB_CONTROL_SERVER_CONFLICT_NDB "mysql-community-server, mysql-commercial-server")
  SET (DEB_CONTROL_CLIENT_CONFLICT_NDB "mysql-community-client, mysql-commercial-client")
  SET (DEB_NOMEB "1")
  SET (DEB_NOROUTER "1")
  SET (DEB_CMAKE_EXTRAS "${DEB_CMAKE_EXTRAS} -DWITH_MEB=0 -DWITH_ROUTER=0")
ELSE()
  SET (DEB_BASE_PRODUCT "")
  SET (DEB_BASE_PRODUCTC "")
  SET (DEB_BASE_VERSION ${VERSION})
  SET (DEB_CONTROL_SERVER_CONFLICT_NDB "mysql-cluster-community-server, mysql-cluster-commercial-server")
  SET (DEB_CONTROL_CLIENT_CONFLICT_NDB "mysql-cluster-community-client, mysql-cluster-commercial-client")
ENDIF()
# Timestamp for use in debian/changelog
IF (NOT DEFINED DEB_CHANGELOG_TIMESTAMP)
  execute_process(
    COMMAND date --rfc-2822
    OUTPUT_VARIABLE DEB_CHANGELOG_TIMESTAMP
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  SET (DEB_CHANGELOG_TIMESTAMP ${DEB_CHANGELOG_TIMESTAMP} CACHE STRING "")
ENDIF()
# Commercial or community
IF (DEB_PRODUCT STREQUAL "commercial")
  SET (DEB_COPYRIGHT_UPSTREAMNAME "MySQL Commercial Server ${MYSQL_BASE_VERSION}")
  SET (DEB_PRODUCTNAME "${DEB_BASE_PRODUCT}commercial")
  SET (DEB_PRODUCTNAMEC "${DEB_BASE_PRODUCTC}Enterprise")
  SET (DEB_NOTPRODUCTNAME "${DEB_BASE_PRODUCT}community")
  SET (DEB_LICENSENAME "Commercial")
  SET (DEB_SERVERVERSION "${DEB_BASE_VERSION}+commercial-1")
  # List of plugins that are only in commercial packages
  # Plugins that are in both community and commercial should NOT be added here
  SET (DEB_INSTALL_SERVER_PLUGINS
"
usr/lib/mysql/plugin/audit_log.so
usr/lib/mysql/plugin/authentication_pam.so
usr/lib/mysql/plugin/authentication_ldap_sasl.so
usr/lib/mysql/plugin/authentication_ldap_simple.so
usr/lib/mysql/plugin/authentication_kerberos.so
usr/lib/mysql/plugin/data_masking.so
usr/lib/mysql/plugin/keyring_okv.so
usr/lib/mysql/plugin/keyring_encrypted_file.so
usr/lib/mysql/plugin/keyring_hashicorp.so
usr/lib/mysql/plugin/keyring_oci.so
usr/lib/mysql/plugin/openssl_udf.so
usr/lib/mysql/plugin/thread_pool.so
usr/lib/mysql/plugin/firewall.so
usr/lib/mysql/plugin/authentication_fido.so
usr/lib/mysql/plugin/component_keyring_encrypted_file.so
usr/lib/mysql/plugin/component_keyring_oci.so
usr/lib/mysql/plugin/component_enterprise_encryption.so
usr/lib/mysql/plugin/component_masking.so
usr/lib/mysql/plugin/component_masking_functions.so
usr/lib/mysql/plugin/component_scheduler.so
")

   SET (DEB_INSTALL_TEST_PLUGINS
"
usr/lib/mysql/plugin/component_test_global_priv_registration.so
usr/lib/mysql/plugin/component_test_page_track_component.so
")

  IF (DEB_AWS_SDK)
    SET (DEB_CMAKE_EXTRAS "${DEB_CMAKE_EXTRAS} -DWITH_KEYRING_AWS=ON -DWITH_AWS_SDK=${DEB_AWS_SDK} -DDEB_AWS_SDK=${DEB_AWS_SDK}")
    SET (DEB_INSTALL_SERVER_PLUGINS "${DEB_INSTALL_SERVER_PLUGINS}
usr/lib/mysql/plugin/keyring_aws.so
")
  ENDIF()

  IF (WITH_CURL)
    SET (DEB_CMAKE_EXTRAS "${DEB_CMAKE_EXTRAS} -DWITH_CURL=${WITH_CURL}")
  ENDIF()
  SET (DEB_REMOVEPATTERN "gpl.in")
  INCLUDE (deb_commercial.cmake)

  IF (NOT DEFINED DEB_NOMEB)
    INCLUDE(deb_meb.cmake)
  ENDIF()
ELSE()
  SET (DEB_PRODUCT "${DEB_BASE_PRODUCT}community")
  SET (DEB_COPYRIGHT_UPSTREAMNAME "MySQL Server ${MYSQL_BASE_VERSION}")
  SET (DEB_PRODUCTNAME "${DEB_BASE_PRODUCT}community")
  SET (DEB_PRODUCTNAMEC "${DEB_BASE_PRODUCTC}Community")
  SET (DEB_NOTPRODUCTNAME "${DEB_BASE_PRODUCT}commercial")
  SET (DEB_LICENSENAME "GPL")
  SET (DEB_SERVERVERSION "${DEB_BASE_VERSION}-1")
  SET (DEB_REMOVEPATTERN "com.in")
ENDIF()

# Build with default ssl. May be overridden if we don't support default ssl version
SET (DEB_CONTROL_BDEPS_SSL ",libssl-dev")
# Generate debug symbol packages (this is done automatically in Debian9+)
SET (DEB_RULES_STRIP_DEFAULT
"
override_dh_strip:
	dh_strip -pmysql-${DEB_PRODUCTNAME}-server-core --dbg-package=mysql-${DEB_PRODUCTNAME}-server-core-dbgsym
	dh_strip -pmysql-${DEB_PRODUCTNAME}-client-core --dbg-package=mysql-${DEB_PRODUCTNAME}-client-core-dbgsym
	dh_strip -pmysql-${DEB_PRODUCTNAME}-server --dbg-package=mysql-${DEB_PRODUCTNAME}-server-dbgsym
	dh_strip -pmysql-${DEB_PRODUCTNAME}-server-debug --dbg-package=mysql-${DEB_PRODUCTNAME}-server-debug-dbgsym
	dh_strip -pmysql-${DEB_PRODUCTNAME}-client --dbg-package=mysql-${DEB_PRODUCTNAME}-client-dbgsym
	dh_strip -pmysql-${DEB_PRODUCTNAME}-test --dbg-package=mysql-${DEB_PRODUCTNAME}-test-dbgsym
	dh_strip -pmysql-${DEB_PRODUCTNAME}-test-debug --dbg-package=mysql-${DEB_PRODUCTNAME}-test-debug-dbgsym
	dh_strip -pmysql-server
	dh_strip -pmysql-client
	dh_strip -pmysql-testsuite
	dh_strip -plibmysqlclient21 --dbg-package=libmysqlclient21-dbgsym
	dh_strip -plibmysqlclient-dev
")
SET (DEB_CONTROL_DBGSYM_DEFAULT
"
Package: libmysqlclient21-dbgsym
Architecture: any
Section: debug
Depends: libmysqlclient21 (=\${binary:Version}), \${misc:Depends}
Description: Debugging symbols for client library

Package: mysql-${DEB_PRODUCTNAME}-test-dbgsym
Architecture: any
Section: debug
Depends: mysql-${DEB_PRODUCTNAME}-test (= \${binary:Version}), \${misc:Depends}
Description: Debugging symbols for test suite

Package: mysql-${DEB_PRODUCTNAME}-test-debug-dbgsym
Architecture: any
Section: debug
Depends: mysql-${DEB_PRODUCTNAME}-test-debug (= \${binary:Version}), \${misc:Depends}
Description: Debugging symbols for test suite debug binaries

Package: mysql-${DEB_PRODUCTNAME}-client-core-dbgsym
Architecture: any
Section: debug
Depends: mysql-${DEB_PRODUCTNAME}-client-core (= \${binary:Version}), \${misc:Depends}
Description: Debugging symbols for client core

Package: mysql-${DEB_PRODUCTNAME}-server-core-dbgsym
Architecture: any
Section: debug
Depends: mysql-${DEB_PRODUCTNAME}-server-core (= \${binary:Version}), \${misc:Depends}
Description: Debugging symbols for server core

Package: mysql-${DEB_PRODUCTNAME}-server-dbgsym
Architecture: any
Section: debug
Depends: mysql-${DEB_PRODUCTNAME}-server (= \${binary:Version}), \${misc:Depends}
Description: Debugging symbols for server

Package: mysql-${DEB_PRODUCTNAME}-server-debug-dbgsym
Architecture: any
Section: debug
Depends: mysql-${DEB_PRODUCTNAME}-server-debug (= \${binary:Version}), \${misc:Depends}
Description: Debugging symbols for server debug binaries

Package: mysql-${DEB_PRODUCTNAME}-client-dbgsym
Architecture: any
Section: debug
Depends: mysql-${DEB_PRODUCTNAME}-client (= \${binary:Version}), \${misc:Depends}
Description: Debugging symbols for client
")

# lsb_release on Debian reports the full version number, e.g. 9.9, and we just want the major version
IF(DEB_ID STREQUAL "debian")
  string(REGEX REPLACE "\\..*" "" DEB_RELEASE "${DEB_RELEASE}")
ENDIF()


# ubuntu18.04, debian9, etc
SET (DEB_PLATFORMRELEASE "${DEB_ID}${DEB_RELEASE}")

# Only used on Ubuntu
SET (DEB_CONTROL_BDEPS "")
SET (DEB_RULES_INSTALL_APPARMOR "")
SET (DEB_RULES_APPARMOR_LOAD "")
SET (DEB_INSTALL_SERVER_APPARMOR "")
SET (DEB_INIT_SERVER_APPARMOR "")
SET (DEB_INIT_ROUTER_APPARMOR "")
# Only used on Ubuntu 16.04 for manually created debug symbol packages
SET (DEB_CONTROL_DBGSYM "")
SET (DEB_RULES_STRIP "")

# Used for testing unreleased gcc versions on e.g. Debian unstable
IF (DEFINED DEB_GCC_SNAPSHOT)
  SET (DEB_CMAKE_EXTRAS "${DEB_CMAKE_EXTRAS} -DCMAKE_C_COMPILER=/usr/lib/gcc-snapshot/bin/gcc -DCMAKE_CXX_COMPILER=/usr/lib/gcc-snapshot/bin/g++ -DMYSQL_MAINTAINER_MODE=0 -DCMAKE_CXX_COMPILER_LAUNCHER=ccache")
ENDIF()

# Enable various apparmor systems for Ubuntu
IF(DEB_ID STREQUAL "ubuntu")
  IF(DEB_CODENAME STREQUAL "bionic")
    SET (DEB_CONTROL_BDEPS ", dh-apparmor, gcc-8, g++-8")
  ELSE()
    SET (DEB_CONTROL_BDEPS ", dh-apparmor")
  ENDIF()
  SET (DEB_RULES_INSTALL_APPARMOR "install -m 0644 -D debian/extra/apparmor-profile debian/tmp/etc/apparmor.d/usr.sbin.mysqld")
  SET (DEB_RULES_APPARMOR_LOAD "dh_apparmor -pmysql-${DEB_PRODUCTNAME}-server --profile-name=usr.sbin.mysqld")
  SET (DEB_INSTALL_SERVER_APPARMOR "etc/apparmor.d/usr.sbin.mysqld")
  SET (DEB_INSTALL_ROUTER_APPARMOR "etc/apparmor.d/usr.bin.mysqlrouter")
  SET (DEB_INIT_SERVER_APPARMOR "/lib/apparmor/profile-load usr.sbin.mysqld")
  SET (DEB_INIT_ROUTER_APPARMOR "/lib/apparmor/profile-load usr.bin.mysqlrouter")

  # Ubuntu 16.04 doesn't automatically create debug symbol packages
  IF(DEB_CODENAME STREQUAL "xenial")
    SET (DEB_CONTROL_DBGSYM ${DEB_CONTROL_DBGSYM_DEFAULT})
    SET (DEB_RULES_STRIP ${DEB_RULES_STRIP_DEFAULT})
  ENDIF()
ENDIF()

IF (NOT DEFINED DEB_NOROUTER)
  INCLUDE(deb_router.cmake)
ENDIF()
IF (WITH_NDB)
  INCLUDE(deb_ndb.cmake)
ENDIF()
if (DEFINED DEB_WITH_DEBUG)
  INCLUDE(deb_debug.cmake)
ENDIF()
# All files are configured and copied to the debian/ directory, which is used 
# by debuild to make the packages
SET (DEB_ROOT ${CMAKE_SOURCE_DIR}/packaging/deb-in)
FILE(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/debian)
FILE(GLOB_RECURSE SOURCEFILES RELATIVE "${DEB_ROOT}" "${DEB_ROOT}/*")
# Skip the copyright file from the "other" product type
LIST(REMOVE_ITEM SOURCEFILES "copyright.${DEB_REMOVEPATTERN}")
LIST(REMOVE_ITEM SOURCEFILES "CMakeLists.txt")
# Don't install systemd file on systems without systemd
IF(DEB_INSTALL_SERVER_SYSTEMD STREQUAL "")
	LIST(REMOVE_ITEM SOURCEFILES "mysql-packagesource-server.mysql.service.in")
ENDIF()
FOREACH (SOURCEFILE ${SOURCEFILES})
  STRING(REGEX REPLACE "-packagesource" "-${DEB_PRODUCTNAME}"
    TMPFILE ${SOURCEFILE})
  # Strip away the input file endings from the destination filenames
  STRING(REGEX REPLACE ".in$" "" TMPFILE ${TMPFILE})
  STRING(REGEX REPLACE ".gpl$" "" TMPFILE ${TMPFILE})
  STRING(REGEX REPLACE ".com$" "" DESTFILE ${TMPFILE})
  CONFIGURE_FILE("${DEB_ROOT}/${SOURCEFILE}"
    "${CMAKE_BINARY_DIR}/debian/${DESTFILE}" @ONLY)
ENDFOREACH()
EXECUTE_PROCESS(
  COMMAND chmod +x ${CMAKE_BINARY_DIR}/debian/rules
)

=== packaging/solaris/CMakeLists.txt ===
# Copyright (c) 2012, 2025, Oracle and/or its affiliates.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA


# Any files in this directory are auxiliary files for Solaris "pkg" packages.
# They will be configured during "pkg" creation, not during (binary) build.

IF(NOT SOLARIS)
  RETURN()
ENDIF()

# Currently, this expands to "support-files/" in most layouts,
# but to "/usr/share/mysql/" in a RPM.
# It is important not to pollute "/usr/bin".
SET(inst_location ${INSTALL_SUPPORTFILESDIR})

FOREACH(script  postinstall-solaris)
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${script}.sh 
                 ${CMAKE_CURRENT_BINARY_DIR}/${script} COPYONLY )

  INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${script} 
     DESTINATION ${inst_location}/solaris COMPONENT Server_Scripts
     PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
ENDFOREACH()

=== plugin/pfs_table_plugin/CMakeLists.txt ===
# Copyright (c) 2009, 2025, Oracle and/or its affiliates.
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

DISABLE_MISSING_PROFILE_WARNING()
ADD_DEFINITIONS(-DMYSQL_SERVER)

MYSQL_ADD_PLUGIN(pfs_example_plugin_employee
  pfs_example_employee_name.cc
  pfs_example_employee_salary.cc
  pfs_example_machine.cc
  pfs_example_machines_by_emp_by_mtype.cc
  pfs_example_plugin_employee.cc
  TEST_ONLY
  MODULE_ONLY
  )

=== plugin/rewriter/CMakeLists.txt ===
# Copyright (c) 2015, 2025, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

MYSQL_ADD_PLUGIN(rewriter
  rewriter.cc
  rewriter_plugin.cc
  rewriter_udf.cc
  rule.cc
  services.cc
  MODULE_ONLY
  MODULE_OUTPUT_NAME "rewriter"
  WIN_DEF_FILE "${CMAKE_CURRENT_SOURCE_DIR}/rewriter_udf.def"
  )

# MYSQL_ADD_PLUGIN may have decided not to build it.
IF(NOT TARGET rewriter)
  RETURN()
ENDIF()

ADD_DEFINITIONS(-DMYSQL_SERVER)
ADD_DEFINITIONS(-DLOG_COMPONENT_TAG="Rewriter")

# We should use CMAKE_SHARED_LIBRARY_SUFFIX, but we do not use .dylib on Mac.
IF(WIN32)
  SET(DYNLIB_EXTENSION "dll")
ELSE()
  SET(DYNLIB_EXTENSION "so")
ENDIF()

#
# This installs all the scripts.
#
FOREACH(file
    install_rewriter
    uninstall_rewriter)

  CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/${file}.sql.in
    ${CMAKE_CURRENT_BINARY_DIR}/${file}.sql
    )

  INSTALL(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/${file}.sql
    DESTINATION ${INSTALL_MYSQLSHAREDIR}
    COMPONENT SupportFiles
    PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
    )

ENDFOREACH()

=== storage/federated/CMakeLists.txt ===
# Copyright (c) 2006, 2025, Oracle and/or its affiliates.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

MYSQL_ADD_PLUGIN(federated ha_federated.cc
  STORAGE_ENGINE DEFAULT_LEGACY_ENGINE
  LINK_LIBRARIES extra::rapidjson
  )

# Exclude federated from PGO on Windows to avoid linker error LNK1248
EXCLUDE_FROM_MSVC_PGO(federated)

=== storage/temptable/CMakeLists.txt ===
# Copyright (c) 2016, 2025, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

MSVC_CPPCHECK_DISABLE()

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/include
)

SET(TEMPTABLE_SOURCES
  src/allocator.cc
  src/block.cc
  src/column.cc
  src/handler.cc
  src/index.cc
  src/indexed_cells.cc
  src/memutils.cc
  src/plugin.cc
  src/result.cc
  src/row.cc
  src/table.cc
  )

IF(NOT LINUX)
  LIST(REMOVE_ITEM TEMPTABLE_SOURCES src/memutils.cc)
ENDIF()

MYSQL_ADD_PLUGIN(temptable
  ${TEMPTABLE_SOURCES}
  STORAGE_ENGINE
  MANDATORY
  LINK_LIBRARIES extra::rapidjson
)

# Only used for debugging.
MY_CHECK_CXX_COMPILER_WARNING("-Wmissing-profile" HAS_WARN_FLAG)
IF(HAS_WARN_FLAG)
  ADD_COMPILE_FLAGS(src/result.cc COMPILE_FLAGS "${HAS_WARN_FLAG}")
ENDIF()

=== unittest/gunit/CMakeLists.txt ===
# Copyright (c) 2010, 2025, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

IF(NOT WITH_UNIT_TESTS)
  RETURN()
ENDIF()

MSVC_CPPCHECK_DISABLE()

IF(WITH_LTO OR CMAKE_COMPILER_FLAG_WITH_LTO)
  # We get ODR violations because of multiple bison parsers.
  MY_CHECK_CXX_COMPILER_WARNING("error=odr" HAS_WARN_FLAG)
  IF(HAS_WARN_FLAG)
    STRING_APPEND(CMAKE_EXE_LINKER_FLAGS " ${HAS_WARN_FLAG}")
  ENDIF()
ENDIF()

# Some tests require Boost.
INCLUDE_DIRECTORIES(SYSTEM ${BOOST_PATCHES_DIR} ${BOOST_INCLUDE_DIR})

INCLUDE_DIRECTORIES(SYSTEM ${GMOCK_INCLUDE_DIRS})

# TODO(sgunders): Remove when all GMock tests use MOCK_METHOD().
STRING(REPLACE "-Wsuggest-override" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")

MY_CHECK_CXX_COMPILER_FLAG("-fno-builtin-memcmp" HAVE_NO_BUILTIN_MEMCMP)

SET(DISABLE_PSI_DEFINITIONS
  "DISABLE_PSI_COND"
  "DISABLE_PSI_FILE"
  "DISABLE_PSI_MEMORY"
  "DISABLE_PSI_METADATA"
  "DISABLE_PSI_MUTEX"
  "DISABLE_PSI_RWLOCK"
  "DISABLE_PSI_STAGE"
  )

# Set these in the cache to make them available globally
SET(DISABLE_PSI_DEFINITIONS ${DISABLE_PSI_DEFINITIONS} CACHE INTERNAL "")

# Set up valgrind options to use with ctest.
# Use `ctest (...) -D ExperimentalMemCheck` to run.
IF(LINUX OR FREEBSD)
  FIND_PROGRAM(MEMORYCHECK_COMMAND valgrind)
  SET(MEMORYCHECK_COMMAND_OPTIONS
    "--leak-check=full --errors-for-leak-kinds=definite,indirect --error-exitcode=42"
    CACHE INTERNAL "")
  SET(MEMORYCHECK_SUPPRESSIONS_FILE "${PROJECT_SOURCE_DIR}/mysql-test/valgrind.supp"
    CACHE INTERNAL "")
ENDIF()

# main-wrapper libraries (with tap-compatible option).
ADD_LIBRARY(gunit_small STATIC
  benchmark.cc
  fake_costmodel.cc
  gunit_test_main.cc
  skip_trailing.cc
  strnxfrm.cc
  thread_utils.cc
  fake_table.cc
)
SET_TARGET_PROPERTIES(gunit_small
  PROPERTIES COMPILE_DEFINITIONS "${DISABLE_PSI_DEFINITIONS}"
)

ADD_STATIC_LIBRARY(gunit_large
  benchmark.cc
  gunit_test_main_server.cc
  test_utils.cc
  thread_utils.cc
  LINK_LIBRARIES ext::icu ext::zlib extra::unordered_dense
)

# Add a library for enable_win_jemalloc.cc
# and link it with both gunit_small and gunit_large below.
UNSET(UNITTEST_JEMALLOC_LIB)
IF(WIN32)
  ADD_LIBRARY(unittest_jemalloc STATIC ../../sql/enable_win_jemalloc.cc)
  SET(UNITTEST_JEMALLOC_LIB unittest_jemalloc)
ENDIF()

ADD_DEPENDENCIES(gunit_small GenError)
ADD_DEPENDENCIES(gunit_large GenError)
TARGET_LINK_LIBRARIES(gunit_small
  mysys strings ${GTEST_LIBRARIES} ${UNITTEST_JEMALLOC_LIB} extra::rapidjson)
TARGET_LINK_LIBRARIES(gunit_large
  mysys strings ${GTEST_LIBRARIES} ${UNITTEST_JEMALLOC_LIB} extra::rapidjson)

IF(WIN32)
  ## Create an object library of nt_servc.cc, so we don't have to
  ## compile it again for each target
  ADD_LIBRARY(my_nt_servc OBJECT ../../sql/nt_servc.cc)
ENDIF()

# Add some defines.
ADD_DEFINITIONS(-DMYSQL_SERVER -DEXTRA_CODE_FOR_UNIT_TESTING)
ADD_DEFINITIONS(-DERRMSG_DIR="${PROJECT_BINARY_DIR}/share")
ADD_DEFINITIONS(-DDATA_DIR="${CMAKE_CURRENT_BINARY_DIR}")

# Add tests (link them with gunit/gmock libraries)
SET(TESTS
  alignment
  bitmap
  bounds_checked_array
  byteorder
  calloc
  charset_bug28956360
  charset_bug32788301
  collation_loader
  cost_estimate
  dbug
  decimal
  dns_srv_data
  dphyp
  dynarray
  filesort_buffer
  filesort_compare
  filesort_mergechunk
  inplace_vector
  integer_digits
  intrusive_list_iterator
  key
  like_range
  m_string
  mdl
  mem_root_deque
  mutex_lock
  my_alloc
  my_bitmap
  my_error
  my_fileutils
  my_gcvt
  my_murmur3
  my_rcu_lock
  my_thread
  my_timer
  mysys_base64
  mysys_lf
  mysys_my_b_vprintf
  mysys_my_checksum
  mysys_my_getopt
  mysys_my_getpw
  mysys_my_loadpath
  mysys_my_malloc
  mysys_my_pwrite
  mysys_my_rdtsc
  mysys_my_read
  mysys_my_symlink
  mysys_my_time
  mysys_my_write
  mysys_pathfuncs
  opt_recperkey
  overflow_bitset
  partitioned_rwlock
  pattern_matcher
  prealloced_array
  priority_queue
  pump_object_filter
  record_buffer
  sql_class_header
  sql_list
  sql_plist
  sql_string
  stl_alloc
  stream_cipher
  strings_skip_trailing
  strings_strnxfrm
  strings_utf8
  strings_valid_check
  strtod
  strtoll
  template_utils
  thread_utils
  timespec
  unhex
  val_int_compare
  )

SET(ALL_SMALL_TESTS)
FOREACH(test ${TESTS})
  LIST(APPEND ALL_SMALL_TESTS ${test}-t.cc)
ENDFOREACH()

# Add tests (link them with gunit/gmock libraries and the server libraries)
SET(SERVER_TESTS
  bgc_ticket_manager
  character_set_deprecation
  compare_access_paths
  connect_joins
  copy_info
  create_field
  dd_cache
  dd_column_statistics
  dd_info_schema_native_func
  dd_pfs
  dd_properties
  dd_schema
  dd_sdi
  dd_string_type
  dd_table
  debug_sync
  decoy_user
  explain_filename
  field
  get_diagnostics
  gis_algos
  gis_area
  gis_buffer
  gis_difference
  gis_distance
  gis_frechet_distance
  gis_geometries
  gis_hausdorff_distance
  gis_intersection
  gis_is_simple
  gis_isvalid
  gis_line_interpolate_point
  gis_relops
  gis_rtree_support
  gis_setops
  gis_srs
  gis_symdifference
  gis_transform
  gis_union
  gis_wkb_parser
  gis_wkb_writer
  graph_simplification
  handler
  hash_join
  histograms
  histogram_selectivity
  hypergraph_optimizer
  initialize_password
  insert_delayed
  interesting_orders
  into_syntax
  item
  item_filter
  item_func_case
  item_func_now_local
  item_func_regexp
  item_json_func
  item_like
  item_timefunc
  join_syntax
  join_tab_sort
  json_binary
  json_dom
  json_path
  locking_clause_syntax
  locking_service
  log_throttle
  log_timestamp
  make_sortkey
  mdl_sync
  my_decimal
  mysqld_funcs
  opt_costconstants
  opt_costmodel
  opt_guessrecperkey
  opt_range
  opt_ref
  opt_trace
  persisted_variables
  protocol_classic
  regexp_engine
  regexp_facade
  security_context
  segfault
  select_lex_visitor
  sha2_password
  sql_table
  subquery_syntax
  table_cache
  table_factor_syntax
  table_list
  tc_log_mmap
  temptable_allocator
  temptable_storage
  thd_manager
  union_syntax
  unique
  value_map
  walk_access_paths
  wild_case_compare
  ha_info_iterator
  xid_extract
  log_event_status_size
)
# Endless loop in FatalSignalDeathTest
IF(LINUX_ALPINE)
  LIST(REMOVE_ITEM SERVER_TESTS segfault)
ENDIF()

IF(MY_COMPILER_IS_GNU AND NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 12)
  ADD_COMPILE_FLAGS(regexp_engine-t.cc COMPILE_FLAGS "-Wno-restrict")
ENDIF()

IF(WIN32)
  LIST(APPEND SERVER_TESTS win_tests)
ENDIF()

# Suppress -Wformat-overflow= for my_safe_snprintf(" %s ", nullptr)
MY_CHECK_CXX_COMPILER_WARNING("format-overflow" HAS_WARN_FLAG)
IF(HAS_WARN_FLAG)
  ADD_COMPILE_FLAGS(segfault-t.cc COMPILE_FLAGS ${HAS_WARN_FLAG})
ENDIF()

# Warnings about missing PGO profile data are not useful for unit tests.
DISABLE_MISSING_PROFILE_WARNING()

SET(ALL_LARGE_TESTS)
FOREACH(test ${SERVER_TESTS})
  LIST(APPEND ALL_LARGE_TESTS ${test}-t.cc)
ENDFOREACH()

SET(SQL_GUNIT_LIB_SOURCE
  ${CMAKE_SOURCE_DIR}/sql/filesort_utils.cc
  ${CMAKE_SOURCE_DIR}/sql/mdl.cc
  ${CMAKE_SOURCE_DIR}/sql/stream_cipher.cc
  ${CMAKE_SOURCE_DIR}/sql/sql_list.cc
  ${CMAKE_SOURCE_DIR}/sql/stateless_allocator.cc
  ${CMAKE_SOURCE_DIR}/sql-common/sql_string.cc
  ${CMAKE_SOURCE_DIR}/sql/thr_malloc.cc
  ${CMAKE_SOURCE_DIR}/sql/join_optimizer/hypergraph.cc
  ${CMAKE_SOURCE_DIR}/sql/join_optimizer/online_cycle_finder.cc
  ${CMAKE_SOURCE_DIR}/sql/join_optimizer/overflow_bitset.cc
  ${CMAKE_SOURCE_DIR}/sql/locks/shared_spin_lock.cc
  )

ADD_LIBRARY(sqlgunitlib STATIC ${SQL_GUNIT_LIB_SOURCE})
ADD_DEPENDENCIES(sqlgunitlib GenError)
SET_TARGET_PROPERTIES(sqlgunitlib
  PROPERTIES COMPILE_DEFINITIONS "${DISABLE_PSI_DEFINITIONS}"
)

MYSQL_ADD_EXECUTABLE(merge_small_tests-t ${ALL_SMALL_TESTS}
  ADD_TEST merge_small_tests
  COMPILE_DEFINITIONS ${DISABLE_PSI_DEFINITIONS}
  ENABLE_EXPORTS
  EXCLUDE_FROM_GCOV
  LINK_LIBRARIES sqlgunitlib gunit_small extra::rapidjson
)

IF(WIN32)
  LIST(APPEND ALL_LARGE_TESTS ../../sql/nt_servc.cc)
ENDIF()
LIST(APPEND ALL_LARGE_TESTS ../../storage/example/ha_example.cc)

MYSQL_ADD_EXECUTABLE(merge_large_tests-t ${ALL_LARGE_TESTS}
  ADD_TEST merge_large_tests
  ENABLE_EXPORTS
  EXCLUDE_FROM_GCOV
  LINK_LIBRARIES gunit_large server_unittest_library
)

FOREACH(test ${TESTS})
  MYSQL_ADD_EXECUTABLE(${test}-t ${test}-t.cc
    COMPILE_DEFINITIONS ${DISABLE_PSI_DEFINITIONS}
    ENABLE_EXPORTS
    EXCLUDE_FROM_ALL
    LINK_LIBRARIES sqlgunitlib gunit_small
    SKIP_INSTALL
    ADD_GCOV_TEST ${test}
  )
ENDFOREACH()

# Disable by default, since it dumps a stack trace.
# We don't want ppl to think there was a segfault or something.
# See also the mtr test main.print_stacktrace
MYSQL_ADD_EXECUTABLE(mysys_stacktrace-t mysys_stacktrace-t.cc
  COMPILE_DEFINITIONS ${DISABLE_PSI_DEFINITIONS}
  ENABLE_EXPORTS
  EXCLUDE_FROM_ALL
  LINK_LIBRARIES sqlgunitlib gunit_small
  SKIP_INSTALL
)

# See comments about __builtin_memcmp in the source file.
IF(HAVE_NO_BUILTIN_MEMCMP)
  ADD_COMPILE_FLAGS(
    filesort_compare-t.cc
    COMPILE_FLAGS "-fno-builtin-memcmp"
    )
ENDIF()

FOREACH(test ${SERVER_TESTS})
  SET(SRC_FILES ${test}-t.cc)
  IF(WIN32)
    LIST(APPEND SRC_FILES $<TARGET_OBJECTS:my_nt_servc>)
  ENDIF()
  IF(test MATCHES "table_cache")
    LIST(APPEND SRC_FILES ../../storage/example/ha_example.cc)
  ENDIF()
  MYSQL_ADD_EXECUTABLE(${test}-t ${SRC_FILES}
    ENABLE_EXPORTS
    EXCLUDE_FROM_ALL
    LINK_LIBRARIES gunit_large server_unittest_library
    SKIP_INSTALL
    ADD_GCOV_TEST ${test}
  )
ENDFOREACH()

ADD_LIBRARY(rpl_channel_credentials_lib STATIC
  ${CMAKE_SOURCE_DIR}/sql/rpl_channel_credentials.cc
)

MYSQL_ADD_EXECUTABLE(rpl_channel_credentials-t rpl_channel_credentials-t.cc
  ENABLE_EXPORTS
  ADD_TEST rpl_channel_credentials
  LINK_LIBRARIES rpl_channel_credentials_lib gunit_small
)

ADD_LIBRARY(rpl_commit_order_queue_lib STATIC
  ${CMAKE_SOURCE_DIR}/sql/changestreams/apply/commit_order_queue.cc
)

MYSQL_ADD_EXECUTABLE(rpl_commit_order_queue-t rpl_commit_order_queue-t.cc
  ENABLE_EXPORTS
  ADD_TEST rpl_commit_order_queue
  LINK_LIBRARIES rpl_commit_order_queue_lib gunit_small sqlgunitlib
)

ADD_SUBDIRECTORY(ddl_rewriter)
ADD_SUBDIRECTORY(innodb)
ADD_SUBDIRECTORY(keyring)
ADD_SUBDIRECTORY(components/mysql_server)
ADD_SUBDIRECTORY(components/keyring_common)
ADD_SUBDIRECTORY(xplugin)
ADD_SUBDIRECTORY(group_replication)
ADD_SUBDIRECTORY(libmysqlgcs)
ADD_SUBDIRECTORY(temptable)
ADD_SUBDIRECTORY(binlogevents)
ADD_SUBDIRECTORY(memory)
ADD_SUBDIRECTORY(containers)
ADD_SUBDIRECTORY(locks)
ADD_SUBDIRECTORY(changestreams)

=== components/keyrings/keyring_file/CMakeLists.txt ===
# Copyright (c) 2021, 2025, Oracle and/or its affiliates.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License, version 2.0,
# as published by the Free Software Foundation.
#
# This program is designed to work with certain software (including
# but not limited to OpenSSL) that is licensed under separate terms,
# as designated in a particular file or component or in included license
# documentation.  The authors of MySQL hereby grant you an additional
# permission to link the program and your derivative works with the
# separately licensed software that they have either included with
# the program or referenced in the documentation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License, version 2.0, for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA

IF (NOT DEFINED WITH_COMPONENT_KEYRING_FILE AND
    NOT DEFINED WITHOUT_COMPONENT_KEYRING_FILE)
  SET(WITH_COMPONENT_KEYRING_FILE 1)
ENDIF()

IF(NOT WITH_COMPONENT_KEYRING_FILE)
  RETURN()
ENDIF()

ADD_DEFINITIONS(-DLOG_COMPONENT_TAG="component_keyring_file")

INCLUDE_DIRECTORIES(
  ${CMAKE_CURRENT_SOURCE_DIR}
)

SET(KEYRING_FILE_SOURCE
  # Encryption handling
  service_implementation/keyring_encryption_service_definition.cc

  # Generator handling
  service_implementation/keyring_generator_service_definition.cc

  # Keyring load handling
  service_implementation/keyring_load_service_definition.cc

  # Keys metadata iterator handling
  service_implementation/keyring_keys_metadata_iterator_service_definition.cc

  # Metadata query handling
  service_implementation/keyring_metadata_query_service_definition.cc

  # Reader handling
  service_implementation/keyring_reader_service_definition.cc

  # Writer handling
  service_implementation/keyring_writer_service_definition.cc

  # Backend handling
  backend/backend.cc

  # Config handling
  config/config.cc

  # Keyring file component handling
  keyring_file.cc

  # Component callbacks
  component_callbacks.cc
)

SET(KEYRING_FILE_LIBRARIES
  keyring_common
  ${SSL_LIBRARIES}
)

MYSQL_ADD_COMPONENT(keyring_file
  ${KEYRING_FILE_SOURCE}
  LINK_LIBRARIES ${KEYRING_FILE_LIBRARIES}
  MODULE_ONLY
)

=== debian/changelog ===
mysql-8.0 (8.0.44-1) unstable; urgency=medium

  * Import upstream version 8.0.44 to fix security issues
    - https://www.oracle.com/security-alerts/cpuoct2025.html#AppendixMSQL
    - CVE-2025-53040 CVE-2025-53042 CVE-2025-53044 CVE-2025-53045
      CVE-2025-53053 CVE-2025-53054 CVE-2025-53062 CVE-2025-53069
    Upstream release notes:
    - https://dev.mysql.com/doc/relnotes/mysql/8.0/en/news-8-0-44.html
    (Closes: #1118543)
  * Remove suggests packages no longer in debian and update recommends
    (Closes: #1118115)

  [ Luca Monducci ]
  * Update it.po translation file (Closes: #1111906)

 -- Lena Voytek <lena.voytek@canonical.com>  Mon, 27 Oct 2025 08:34:23 -0400

mysql-8.0 (8.0.43-3) unstable; urgency=medium

  * Fix permissions and startup race condition in logrotate config.
    (Closes: #544013)
  * Update uploaders list, removing those who are no longer involved with the
    package. Thank you all for your work! (Closes: #1006717)
  * Add missing full stops to translations. (Closes: #1092213)
  * Update debian compat to 13.
    - Use dh_installsystemd to match compatibility.
    - Replace install --fail-missing with dh_missing.
  * Update standards version.
  * Remove set -e and set -u usage in init script. (Closes: #621020)
  * Clean up license text in d/copyright.
  * Remove file permissions updates in d/rules, fixed upstream.
  * Add missing symbols to symbols file.

 -- Lena Voytek <lena.voytek@canonical.com>  Fri, 22 Aug 2025 13:53:55 -0400

mysql-8.0 (8.0.43-2) unstable; urgency=medium

  * Update build dependencies
    - Remove explicit dependency on dh-systemd
    - Update libncurses5-dev to libncurses-dev
    - Update pkg-config to pkgconf
  * Update copyright file
    - Use https for copyright links
    - Update copyrights for added and removed files

 -- Lena Voytek <lena.voytek@canonical.com>  Thu, 24 Jul 2025 08:44:58 -0400

mysql-8.0 (8.0.43-1) unstable; urgency=medium

  * Import upstream version 8.0.43 to fix security issues
    - https://www.oracle.com/security-alerts/cpujul2025.html#AppendixMSQL
    - CVE-2024-9287 CVE-2025-0725 CVE-2025-53023 CVE-2025-5399 CVE-2025-32415
      CVE-2025-50068 CVE-2025-50077 CVE-2025-50078 CVE-2025-50079
      CVE-2025-50080 CVE-2025-50081 CVE-2025-50082 CVE-2025-50083
      CVE-2025-50084 CVE-2025-50085 CVE-2025-50086 CVE-2025-50087
      CVE-2025-50092 CVE-2025-50091 CVE-2025-50093 CVE-2025-50094
      CVE-2025-50096 CVE-2025-50097 CVE-2025-50098 CVE-2025-50099
      CVE-2025-50100 CVE-2025-50101 CVE-2025-50102 CVE-2025-50104
    Upstream release notes:
    - https://dev.mysql.com/doc/relnotes/mysql/8.0/en/news-8-0-43.html
    (Closes: #1109372)
  * Reduce lintian errors and warnings:
    - d/copyright: Update copyright to match current status of upstream files
    - d/source/lintian-overrides: Fix JSON override to match the actual error
    - d/control: Add explicit dh-systemd build dependency.

  [ Jathan ]
  * Update es.po translation file (Closes: #1104481)

  [ Carles Pina i Estany ]
  * Update ca.po translation file (Closes: #1106021)

  [ Américo Monteiro ]
  * Update pt.po translation file (Closes: #1107441)

 -- Lena Voytek <lena.voytek@canonical.com>  Wed, 23 Jul 2025 10:30:16 -0400

mysql-8.0 (8.0.42-1) unstable; urgency=medium

  * Imported upstream version 8.0.42 to fix security issues
    - https://www.oracle.com/security-alerts/cpuapr2025.html#AppendixMSQL
    - CVE-2024-13176 CVE-2024-40896 CVE-2025-21574 CVE-2025-21575
      CVE-2025-21577 CVE-2025-21579 CVE-2025-21580 CVE-2025-21581
      CVE-2025-21584 CVE-2025-21585 CVE-2025-30681 CVE-2025-30682
      CVE-2025-30683 CVE-2025-30684 CVE-2025-30685 CVE-2025-30687
      CVE-2025-30688 CVE-2025-30689 CVE-2025-30693 CVE-2025-30695
      CVE-2025-30696 CVE-2025-30699 CVE-2025-30703 CVE-2025-30704
      CVE-2025-30705 CVE-2025-30710 CVE-2025-30715 CVE-2025-30721
      CVE-2025-30722 CVE-2025-30722
    Upstream release notes:
    - https://dev.mysql.com/doc/relnotes/mysql/8.0/en/news-8-0-42.html
    (Closes: #1103385)

    [ Adriano Rafael Gomes ]
    * Update pt_BR.po translation file (Closes: #1099806)

    [ Remus-Gabriel Chelu ]
    * Update ro.po translation file (Closes: #1101821)

    [ Atila KOÇ ]
    * Update tr.po translation file (Closes: #1102290)

 -- Lena Voytek <lena.voytek@canonical.com>  Wed, 16 Apr 2025 18:05:42 -0400

mysql-8.0 (8.0.41-3) unstable; urgency=medium

  * d/mysql-server.postinst: Update debian-sys-maint user setup to use
    auth_socket instead of unsecure random password (Closes: #1095622)

  [ Frans Spiesschaert ]
  * Update nl.po translation file (Closes: #1094155)

 -- Lena Voytek <lena.voytek@canonical.com>  Fri, 21 Feb 2025 09:37:43 -0500

mysql-8.0 (8.0.41-2) unstable; urgency=medium

  * Add explicit Rules-Requires-Root: binary-targets to fix Debian builds
    (Closes: #1089396)

  [ Helge Kreutzmann ]
  * Update de.po translation file (Closes: #1092212)

  [ Martin Bagge ]
  * Update sv.po translation file (Closes: #1056664)

  [ Atila KOÇ ]
  * Update tr.po translation file (Closes: #1032516)

  [ Remus-Gabriel Chelu ]
  * Update ro.po translation file (Closes: #1031158)

 -- Lena Voytek <lena.voytek@canonical.com>  Fri, 24 Jan 2025 09:30:47 -0500

mysql-8.0 (8.0.41-1) unstable; urgency=medium

  * Imported upstream version 8.0.41 to fix security issues
    - https://www.oracle.com/security-alerts/cpujan2025.html#AppendixMSQL
    - CVE-2024-11053 CVE-2025-21490 CVE-2025-21491 CVE-2025-21495
      CVE-2025-21497 CVE-2025-21500 CVE-2025-21501 CVE-2025-21503
      CVE-2025-21505 CVE-2025-21518 CVE-2025-21519 CVE-2025-21520
      CVE-2025-21522 CVE-2025-21523 CVE-2025-21529 CVE-2025-21531
      CVE-2025-21540 CVE-2025-21543 CVE-2025-21546 CVE-2025-21555
      CVE-2025-21559
    Upstream release notes:
    - https://dev.mysql.com/doc/relnotes/mysql/8.0/en/news-8-0-41.html
    (Closes: #1093877)

 -- Lena Voytek <lena.voytek@canonical.com>  Thu, 23 Jan 2025 09:08:13 -0500

mysql-8.0 (8.0.40-2) unstable; urgency=medium



=== debian/control ===
Source: mysql-8.0
Section: database
Priority: optional
Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
Uploaders: Lena Voytek <lena.voytek@canonical.com>,
           Lars Tangvald <lars.tangvald@oracle.com>
Build-Depends: bison,
               chrpath,
               cmake,
               debhelper-compat (= 13),
               dh-apparmor,
               dpkg-dev (>= 1.16.1~),
               libaio-dev[linux-any],
               libcurl4-openssl-dev,
               libedit-dev,
               libevent-dev,
               libexpect-perl,
               libicu-dev,
               libjson-perl,
               liblz4-dev (>= 0.0~r131),
               libmecab-dev,
               libncurses-dev (>= 5.0-6),
               libnuma-dev [amd64 arm64 i386 mips mips64el mipsel powerpc ppc64el],
               libprotobuf-dev,
               libprotoc-dev,
               libssl-dev,
               libtirpc-dev,
               libwrap0-dev (>= 7.6-8.3),
               libzstd-dev,
               lsb-release,
               lz4,
               perl,
               pkgconf,
               po-debconf,
               protobuf-compiler,
               psmisc,
               unzip,
               zlib1g-dev (>= 1:1.1.3-5)
Standards-Version: 4.7.2
Rules-Requires-Root: binary-targets
Homepage: http://dev.mysql.com/
Vcs-Git: https://salsa.debian.org/mariadb-team/mysql.git -b mysql-8.0/debian/latest
Vcs-Browser: https://salsa.debian.org/mariadb-team/mysql
XS-Testsuite: autopkgtest

Package: libmysqlclient21
Section: libs
Architecture: any
Depends: mysql-common (>= 5.5), ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: MySQL database client library
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes the client library.

Package: libmysqlclient-dev
Architecture: any
Section: libdevel
Depends: libmysqlclient21 (= ${binary:Version}),
         libssl-dev,
         libzstd-dev,
         zlib1g-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: libmysqld-dev (<< 8.0)
Replaces: libmysqld-dev (<< 8.0)
Description: MySQL database development files
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes development libraries and header files.

Package: mysql-client-core-8.0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: virtual-mysql-client-core
Conflicts: mariadb-client-10.1,
           mariadb-client-10.3,
           mariadb-client-core-10.1,
           mariadb-client-core-10.3,
           mysql-client-5.7,
           mysql-client-core-5.7,
           virtual-mysql-client-core
Description: MySQL database core client binaries
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes the core client files, as used by Akonadi.

Package: mysql-client-8.0
Architecture: any
Depends: debianutils (>=1.6),
         mysql-client-core-8.0,
         mysql-common (>= 5.5),
         ${misc:Depends},
         ${shlibs:Depends}
Provides: virtual-mysql-client
Conflicts: mariadb-client-10.1,
           mariadb-client-10.3,
           mysql-client-5.7,
           virtual-mysql-client
Description: MySQL database client binaries
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes the client binaries and the additional tool
 mysqlreport.

Package: mysql-server-core-8.0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: virtual-mysql-server-core
Conflicts: mariadb-server-10.1,
           mariadb-server-10.3,
           mariadb-server-core-10.1,
           mariadb-server-core-10.3,
           mysql-server-5.7,
           mysql-server-core-5.7,
           virtual-mysql-server-core
Description: MySQL database server binaries
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes the server binaries but doesn't contain all the
 infrastructure needed to setup system databases.

Package: mysql-server-8.0
Architecture: any
Recommends: libhtml-template-perl, mecab-ipadic
Pre-Depends: adduser (>= 3.40), debconf, mysql-common (>= 5.5)
Depends: lsb-base (>= 3.0-10),
         mysql-client-8.0 (>= ${binary:Version}),
         mysql-common (>= 5.8+1.0.4~),
         mysql-server-core-8.0 (= ${binary:Version}),
         passwd,
         perl:any (>= 5.6),
         psmisc,
         ${misc:Depends},
         ${shlibs:Depends}
Provides: virtual-mysql-server
Conflicts: mariadb-server-10.1,
           mariadb-server-10.3,
           mysql-server-5.7,
           virtual-mysql-server
Description: MySQL database server binaries and system database setup
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package contains all the infrastructure needed to setup system
 databases.

Package: mysql-server
Architecture: all
Depends: mysql-server-8.0, ${misc:Depends}
Description: MySQL database server (metapackage depending on the latest version)
 This is an empty package that depends on the current "best" version of
 mysql-server (currently mysql-server-8.0), as determined by the MySQL
 maintainers. Install this package if in doubt about which MySQL
 version you need. That will install the version recommended by the
 package maintainers.
 .
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.

Package: mysql-client
Architecture: all
Depends: mysql-client-8.0, ${misc:Depends}
Description: MySQL database client (metapackage depending on the latest version)
 This is an empty package that depends on the current "best" version of
 mysql-client (currently mysql-client-8.0), as determined by the MySQL
 maintainers.  Install this package if in doubt about which MySQL version
 you want, as this is the one considered to be in the best shape by the
 Maintainers.

Package: mysql-testsuite
Architecture: all
Depends: mysql-testsuite-8.0, ${misc:Depends}
Description: MySQL regression tests
 This is an empty package that depends on the current "best" version of
 mysql-testsuite (currently mysql-testsuite-8.0), as determined by the
 MySQL maintainers.  Install this package if in doubt about which MySQL
 version you want, as this is the one we consider to be in the best shape.

Package: mysql-testsuite-8.0
Architecture: any
Depends: libjson-perl,
         lz4,
         mysql-client-8.0 (= ${binary:Version}),
         mysql-server-8.0 (= ${binary:Version}),
         unzip,
         ${misc:Depends},
         ${shlibs:Depends}
Provides: virtual-mysql-testsuite
Conflicts: mariadb-testsuite-10.1,
           mariadb-testsuite-10.3,
           mysql-testsuite-5.7,
           virtual-mysql-testsuite
Description: MySQL 8.0 testsuite
 MySQL is a fast, stable, and true multi-user, multi-threaded SQL database
 server.  SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes the MySQL testsuite.

Package: mysql-source-8.0
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: MySQL source
 MySQL is a fast, stable, and true multi-user, multi-threaded SQL database
 server.  SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes the MySQL source code as configured before building
 - but after the arch specific configuration. This is currently required for
 building plugins.

Package: mysql-router
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: route connections from MySQL clients to MySQL servers
 MySQL Router is part of InnoDB cluster, and is lightweight middleware that
 provides transparent routing between your application and back-end MySQL
 servers. It can be used for a wide variety of use cases, such as providing
 high availability and scalability by effectively routing database traffic to
 appropriate back-end MySQL servers. The pluggable architecture also enables
 developers to extend MySQL Router for custom use cases.
 .
 Since MySQL Router is clustering software and needs to be configured and
 managed across an entire cluster, packaging cannot manage it for you. This
 package supplies the binary build only, ready for manual configuration.
Homepage: https://dev.mysql.com/doc/mysql-router/8.0/en/

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# enable Debian Hardening
# see: https://wiki.debian.org/Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

ARCH := $(shell dpkg-architecture -qDEB_BUILD_ARCH)
ARCH_OS := $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)
BUILDDIR := builddir
builddir = $(BUILDDIR)
DEBVERSION := $(shell dpkg-parsechangelog | awk '/^Version: / { print $$2 }' | sed 's/^.*-//' )
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_BUILD_GNU_SYSTEM ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_SYSTEM)
DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_SOURCE_PACKAGE ?= $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))
DEB_VERSION ?= $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
DEB_NOEPOCH_VERSION ?= $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION ?= $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_UPSTREAM_VERSION_MAJOR_MINOR := $(shell echo $(DEB_UPSTREAM_VERSION) | sed -r -n 's/^([0-9]+\.[0-9]+).*/\1/p')
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DISTRIBUTION := $(shell lsb_release -i -s)
EXPORTED_SOURCE_TARBALL := debian/mysql-source-8.0.tar.gz
TMP := $(CURDIR)/debian/tmp/
NUMJOBS=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
TESTJOBS=$(NUMJOBS)
# Some tests will fail on platforms that are not tested by upstream
ifneq (,$(filter $(ARCH), amd64 i386 armhf))
    TESTSUITE_FAIL_CMD:=exit 1
else
    TESTSUITE_FAIL_CMD:=true
endif

ifeq (,$(NUMJOBS))
	NUMJOBS=1
endif

MAKEFLAGS += -j $(NUMJOBS)

# The below system setting constrains how many servers can be run in parallel
# A server with default config needs a bit over 5300 slots, so we assume 6000 to be sure
AIOMAX := $(shell cat /proc/sys/fs/aio-max-nr)
AIOPER := 6000
PARMAX := $(shell echo $$(( $(AIOMAX)/$(AIOPER))))

ifeq ($(shell test $(TESTJOBS) -gt $(PARMAX); echo $$?),0)
	TESTJOBS:=$(shell echo $(PARMAX) )
endif

export MYSQL_BUILD_CC=$(DEB_HOST_GNU_TYPE)-gcc
export MYSQL_BUILD_CXX=$(DEB_HOST_GNU_TYPE)-g++

# The full upstream test suite takes a very long time to run, so we run
# only the main test suite unless fulltest is specified.
ifeq ($(findstring fulltest,$(DEB_BUILD_OPTIONS)),)
    MTR_SUITE=--suite=main
endif


override_dh_auto_clean:
	@echo "RULES.$@"
	dh_testdir 
	dh_testroot
	[ ! -d mysql-test/var ] || rm -rf mysql-test/var
	rm -rf $(BUILDDIR)
	debconf-updatepo
	rm -f $(EXPORTED_SOURCE_TARBALL)

override_dh_prep: 

override_dh_auto_configure: configure-stamp


configure-stamp:
	@echo "RULES.$@"
	dh_testdir
	( test -d $(builddir) || mkdir $(builddir) ) && cd $(builddir) && \
	sh -c  'PATH=$${MYSQL_BUILD_PATH:-"/bin:/usr/bin"} \
		CC=$${MYSQL_BUILD_CC:-gcc} \
		CXX=$${MYSQL_BUILD_CXX:-g++} \
		cmake -DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DMYSQL_UNIX_ADDR=/var/run/mysqld/mysqld.sock \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DBUILD_CONFIG=mysql_release \
		-DWITH_LIBWRAP=OFF \
		-DWITH_SYSTEM_LIBS=ON \
		-DWITH_MECAB=system \
		-DWITH_ZLIB=system \
		-DWITH_BOOST=../boost \
		-DCOMPILATION_COMMENT="($(DISTRIBUTION))" \
		-DMYSQL_SERVER_SUFFIX="-$(DEBVERSION)" \
		-DINSTALL_LAYOUT=DEB \
		-DINSTALL_DOCDIR=share/mysql/docs \
		-DINSTALL_DOCREADMEDIR=share/mysql \
		-DINSTALL_INCLUDEDIR=include/mysql \
		-DINSTALL_INFODIR=share/mysql/docs \
		-DINSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH) \
		-DINSTALL_MANDIR=share/man \
		-DINSTALL_MYSQLSHAREDIR=share/mysql \
		-DINSTALL_MYSQLTESTDIR=lib/mysql-test \
		-DINSTALL_PLUGINDIR=lib/mysql/plugin \
		-DINSTALL_SBINDIR=sbin \
		-DINSTALL_SCRIPTDIR=bin \
		-DINSTALL_SUPPORTFILESDIR=share/mysql \
		-DSYSCONFDIR=/etc/mysql \
		-DWITH_EMBEDDED_SERVER=ON \
		-DWITH_ARCHIVE_STORAGE_ENGINE=ON \
		-DWITH_BLACKHOLE_STORAGE_ENGINE=ON \
		-DWITH_FEDERATED_STORAGE_ENGINE=ON \
		-DWITH_INNODB_MEMCACHED=1 \
		-DWITH_EXTRA_CHARSETS=all \
		-DROUTER_INSTALL_LIBDIR=lib/mysql-router \
		-DWITH_FIDO=bundled \
		..'
	touch $@

override_dh_auto_build: build-stamp

# $(EXPORTED_SOURCE_TARBALL) must be built before the builds commence, since
# the builds change some of the files picked up by this tar invocation, and
# this can race against tar with an error like "tar:
# ./builddir-pic/strings/CMakeFiles/strings.dir: file changed as we read it".
# So define the rule for building it here, and have the build rules depend on
# it.
$(EXPORTED_SOURCE_TARBALL):
	GZIP=-n tar -zcf $(EXPORTED_SOURCE_TARBALL) \
	    --exclude=debian . \
	    --transform="s,^\./,mysql-8.0/,"

build-stamp: $(EXPORTED_SOURCE_TARBALL)
	@echo "RULES.$@"
	cd $(builddir) && $(MAKE)
	touch $@

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	@echo "RULES.$@"
ifeq ($(ARCH_OS),hurd)
	# Tests not fully working under Hurd, see
	# http://bugs.mysql.com/bug.php?id=64685. Run unit tests only.
	cd $(builddir) && $(MAKE) test || $(TESTSUITE_FAIL_CMD) ;
else
	touch $(builddir)/mysql-test/skiplist
	# Tests that are known to be unstable on all platforms are skipped
	# http://bugs.mysql.com/bug.php?id=83340
	echo "main.xa_prepared_binlog_off	: BUG#00000 - unstable test" >> $(builddir)/mysql-test/skiplist
	echo "main.mysql_client_test		: BUG#100274 - unstable test" >> $(builddir)/mysql-test/skiplist
	echo "main.type_float			: BUG#92375 - fails on ppc64el. Ref https://bugs.mysql.com/bug.php?id=92375" >> $(builddir)/mysql-test/skiplist
	echo "main.type_newdecimal		: BUG#92375 - Same as above" >> $(builddir)/mysql-test/skiplist
	echo "main.type_ranges			: BUG#92375 - Same as above" >> $(builddir)/mysql-test/skiplist
	# https://bugs.mysql.com/bug.php?id=86608
	echo "main.mysqlpump_basic		: BUG#00000 - needs openssl with zlib" >> $(builddir)/mysql-test/skiplist
	# Test is broken for 32bit. Fixed upstream, so remove in 8.0.12+
	echo "main.window_functions_explain	: BUG#00000 -  broken on i386" >> $(builddir)/mysql-test/skiplist
	# New test in 8.0.26, needs investigation
	echo "main.slow_log			: BUG#00000 -  broken" >> $(builddir)/mysql-test/skiplist
	# Test is broken for 32bit.
	echo "main.index_merge_myisam		: BUG#00000 -  broken on i386" >> $(builddir)/mysql-test/skiplist

	# Skip replication tests since they are timing sensitive and may
	# result in false positives.
	cd $(builddir)/mysql-test && ./mtr --suite-timeout=600 --testcase-timeout=60 --report-unstable-tests --parallel=$(TESTJOBS) --skip-rpl $(MTR_SUITE) --force --skip-test-list=./skiplist || $(TESTSUITE_FAIL_CMD) ;
endif
endif

override_dh_auto_install: auto_install-stamp

auto_install-stamp:
	@echo "RULES.$@"
	dh_testdir
	dh_testroot
	# make install (trailing slash needed for innobase)
	cd $(builddir) && $(MAKE) install DESTDIR=$(TMP)/
	# After installing, remove rpath to make lintian happy.
	set +e; \
	find ./debian/tmp/ -type f -print0 \
		| xargs -0 --no-run-if-empty chrpath -k 2>/dev/null \
		| fgrep RPATH= \
		| cut -d: -f 1 \
		| xargs --no-run-if-empty chrpath -d; \
	set -e
	install -d -m 0755 -o root -g root $(TMP)/usr/lib/mysql
	mkdir -p $(TMP)/usr/share/doc/mysql-server-8.0
	nm -n $(BUILDDIR)/bin/mysqld |gzip -n -9 > $(TMP)/usr/share/doc/mysql-server-8.0/mysqld.sym.gz
	# This seems to be the only safe place to fix permissions issues
	# not handled by dh_fixperms.
	install -m 0755 debian/additions/echo_stderr $(TMP)/usr/share/mysql/
	mkdir -p $(TMP)/etc/mysql
	install -m 0755 debian/additions/debian-start $(TMP)/etc/mysql/
	install -m 0644 debian/additions/debian_create_root_user.sql $(TMP)/usr/share/mysql/
	# install AppArmor profile
	install -D -m 644 debian/additions/apparmor-profile $(TMP)/etc/apparmor.d/usr.sbin.mysqld
	touch $@


override_dh_installlogrotate-arch:
	dh_installlogrotate --name mysql-server

override_dh_install:
	dh_install \
		-Xusr/share/man \
		-Xusr/share/mysql/mysql.server \
		-Xmysql.info
	dh_apparmor -pmysql-server-8.0 --profile-name=usr.sbin.mysqld

override_dh_missing:
	dh_missing --fail-missing \
		-Xusr/share/man \
